package com.ejie.y42b.dao;

/**
 * T17CalleDao  
 */

import java.util.List;

import com.ejie.x38.dto.Pagination;
import com.ejie.y42b.model.T17Calle;
import com.ejie.y42b.model.T17Portal;

/**
 * T17CalleDao  
 * 
 *  
 */
public interface T17CalleDao {
	/**
	 * Inserts a single row in the T17Calle table.
	 * 
	 * @param t17calle T17Calle
	 * @return T17Calle
	 */
	T17Calle add(T17Calle t17calle);

	/**
	 * Updates a single row in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @return T17Calle
	 */
	T17Calle update(T17Calle t17calle);

	/**
	 * Finds a single row in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @return T17Calle
	 */
	T17Calle find(T17Calle t17calle);

	/**
	 * Deletes a single row in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * 
	 */
	void remove(T17Calle t17calle);

	/**
	 * Finds a List of rows in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<T17Calle> findAll(T17Calle t17calle, Pagination pagination);

	/**
	 * Counts rows in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @return List
	 */
	Long findAllCount(T17Calle t17calle);

	/**
	 * Finds rows in the T17Calle table using like.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @param pagination
	 *            Pagination            
	 * @param startsWith Boolean           
	 * @return List
	 */
	List<T17Calle> findAllLike(T17Calle t17calle, Pagination pagination,
			Boolean startsWith);
	
	/**
	 * Finds the provincia and municipio associated to the CP
	 * 
	 * @param t17Portal
	 *            T17Portal
	 * @return T17Calle
	 */
	public T17Calle findProvMun(T17Portal t17Portal);
	
	
	/**
	 * Finds rows in the T17Calle table using like.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<T17Calle> findAllCalleLike(T17Calle t17calle, Pagination pagination,
			Boolean startsWith);

	/**
	 * Counts rows in the T17Calle table.
	 * 
	 * @param t17calle
	 *            T17Calle
	 * @param startsWith
	 *            Boolean            
	 * @return List
	 */
	Long findAllCalleLikeCount(T17Calle t17calle, Boolean startsWith);
}
