package com.ejie.y42b.dao;

/**
 * T17PortalDao  
 */

import java.util.List;

import com.ejie.x38.dto.Pagination;
import com.ejie.y42b.model.T17Portal;

/**
 * T17PortalDao  
 * 
 *  
 */
public interface T17PortalDao {
	/**
	 * Inserts a single row in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @return T17Portal
	 */
	T17Portal add(T17Portal t17portal);

	/**
	 * Updates a single row in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @return T17Portal
	 */
	T17Portal update(T17Portal t17portal);

	/**
	 * Finds a single row in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @return T17Portal
	 */
	T17Portal find(T17Portal t17portal);

	/**
	 * Deletes a single row in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * 
	 */
	void remove(T17Portal t17portal);

	/**
	 * Finds a List of rows in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	List<T17Portal> findAll(T17Portal t17portal, Pagination pagination);

	/**
	 * Counts rows in the T17Portal table.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @return List
	 */
	Long findAllCount(T17Portal t17portal);

	/**
	 * Finds rows in the T17Portal table using like.
	 * 
	 * @param t17portal
	 *            T17Portal
	 * @param pagination Pagination            
	 * @param startsWith Boolean
	 * @return List
	 */
	List<T17Portal> findAllLike(T17Portal t17portal, Pagination pagination, Boolean startsWith);

	/**
	 * Finds a List of distinct rows by CP in the T17Portal table.
	 * 
	 * @param t17Portal
	 *            T17Portal
	 * @param pagination Pagination            
	 * @param startsWith Boolean
	 * 
	 * @return List
	 */
	List<T17Portal> findAllLikeCodigoPostal(T17Portal t17Portal, Pagination pagination, Boolean startsWith);
	
	
	/**
	 * Finds a List of distinct CP rows in the T17Portal table.
	 * 
	 * @param t17Portal
	 *            T17Portal
	 * @return T17Portal
	 */
	public T17Portal findCodigoPostal(T17Portal t17Portal);
}
